prototypes: bifrost: Remove /opt/stack from previous deployments
[releng.git] / jjb / xci / bifrost-verify.sh
1 #!/bin/bash
2 # SPDX-license-identifier: Apache-2.0
3 ##############################################################################
4 # Copyright (c) 2016 Ericsson AB and others.
5 # All rights reserved. This program and the accompanying materials
6 # are made available under the terms of the Apache License, Version 2.0
7 # which accompanies this distribution, and is available at
8 # http://www.apache.org/licenses/LICENSE-2.0
9 ##############################################################################
10 set -o errexit
11 set -o nounset
12 set -o pipefail
13
14 trap cleanup_and_upload EXIT
15
16 function upload_logs() {
17     BIFROST_CONSOLE_LOG="${BUILD_URL}/consoleText"
18     BIFROST_GS_URL=${BIFROST_LOG_URL/http:/gs:}
19
20     # Make sure the old landing page is gone in case
21     # we break later on. We don't want to publish
22     # stale information.
23     # TODO: Maybe cleanup the entire $BIFROST_GS_URL directory
24     # before we upload the new data.
25     gsutil -q rm ${BIFROST_GS_URL}/index.html || true
26
27     echo "Uploading collected bifrost build logs to ${BIFROST_LOG_URL}"
28
29     if [[ -d ${WORKSPACE}/logs ]]; then
30         pushd ${WORKSPACE}/logs &> /dev/null
31         for x in *.log; do
32             echo "Compressing and uploading $x"
33             gsutil -q cp -Z ${x} ${BIFROST_GS_URL}/${x}
34         done
35         popd &> /dev/null
36     fi
37
38     echo "Generating the ${BIFROST_LOG_URL}/index.html landing page"
39     cat > ${WORKSPACE}/index.html <<EOF
40 <html>
41 <h1>Build results for <a href=https://$GERRIT_NAME/#/c/$GERRIT_CHANGE_NUMBER/$GERRIT_PATCHSET_NUMBER>$GERRIT_NAME/$GERRIT_CHANGE_NUMBER/$GERRIT_PATCHSET_NUMBER</a></h1>
42 <h2>Job: <a href=${BUILD_URL}>$JOB_NAME</a></h2>
43 <ul>
44 <li><a href=${BIFROST_LOG_URL}/build_log.txt>build_log.txt</a></li>
45 EOF
46
47     if [[ -d ${WORKSPACE}/logs ]]; then
48         pushd ${WORKSPACE}/logs &> /dev/null
49         for x in *.log; do
50             echo "<li><a href=${BIFROST_LOG_URL}/${x}>${x}</a></li>" >> ${WORKSPACE}/index.html
51         done
52         popd &> /dev/null
53     fi
54
55     cat >> ${WORKSPACE}/index.html << EOF
56 </ul>
57 </html>
58 EOF
59
60     # Finally, download and upload the entire build log so we can retain
61     # as much build information as possible
62     echo "Uploading the final console output"
63     curl -s -L ${BIFROST_CONSOLE_LOG} > ${WORKSPACE}/build_log.txt
64     gsutil -q cp -Z ${WORKSPACE}/build_log.txt ${BIFROST_GS_URL}/build_log.txt
65     rm ${WORKSPACE}/build_log.txt
66
67     # Upload landing page
68     gsutil -q cp ${WORKSPACE}/index.html ${BIFROST_GS_URL}/index.html
69     rm ${WORKSPACE}/index.html
70 }
71
72 function fix_ownership() {
73     if [ -z "${JOB_URL+x}" ]; then
74         echo "Not running as part of Jenkins. Handle the logs manually."
75     else
76         # Make sure cache exists
77         [[ ! -d ${HOME}/.cache ]] && mkdir ${HOME}/.cache
78
79         sudo chown -R jenkins:jenkins $WORKSPACE
80         sudo chown -R jenkins:jenkins ${HOME}/.cache
81     fi
82 }
83
84 function cleanup_and_upload() {
85     original_exit=$?
86     fix_ownership
87     upload_logs
88     exit $original_exit
89 }
90
91 # check distro to see if we support it
92 if [[ ! "$DISTRO" =~ (trusty|centos7|suse) ]]; then
93     echo "Distro $DISTRO is not supported!"
94     exit 1
95 fi
96
97 # remove previously cloned repos
98 sudo /bin/rm -rf /opt/bifrost /opt/releng
99
100 # Fix up permissions
101 fix_ownership
102
103 # clone all the repos first and checkout the patch afterwards
104 sudo git clone https://git.openstack.org/openstack/bifrost /opt/bifrost
105 sudo git clone https://gerrit.opnfv.org/gerrit/releng /opt/releng
106
107 # checkout the patch
108 cd $CLONE_LOCATION
109 sudo git fetch $PROJECT_REPO $GERRIT_REFSPEC && sudo git checkout FETCH_HEAD
110
111 # combine opnfv and upstream scripts/playbooks
112 sudo /bin/cp -rf /opt/releng/prototypes/bifrost/* /opt/bifrost/
113
114 # cleanup remnants of previous deployment
115 cd /opt/bifrost
116 sudo -E ./scripts/destroy-env.sh
117
118 # provision 3 VMs; xcimaster, controller, and compute
119 cd /opt/bifrost
120 sudo -E ./scripts/bifrost-provision.sh
121
122 # list the provisioned VMs
123 cd /opt/bifrost
124 source env-vars
125 ironic node-list
126 virsh list